package com.docus.bgts.config;

import com.docus.bgts.enums.Codes;
import com.docus.bgts.facade.IBgtsService;
import com.docus.bgts.utils.FileUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;

@Component
public class MyConstruct {

    @Autowired
    IBgtsService bgtsService;

    private Logger logger = LogManager.getLogger(MyConstruct.class);

    /**
     * 开启手麻全量采集
     */
    @PostConstruct
    public void startCollectAll(){
        logger.info("全量采集开始------");
        String collectorid = String.valueOf(FileUtils.getJsonByName("collectorid"));
        String startCollectTime = String.valueOf(FileUtils.getJsonByName("startCollectTime"));
        String isStartCollect = String.valueOf(FileUtils.getJsonByName("isStartCollect"));
        if(collectorid.equals(Codes.SMCODE.getCode())&& StringUtils.isNotBlank(startCollectTime)&&isStartCollect!=null&&isStartCollect.equals("1")){
            bgtsService.collectAll();
        }
    }

    /**
     * 开启重症全量采集
     */
//    @PostConstruct
//    public void startCollectAll(){
//        logger.info("全量采集开始------");
//        String collectorid = String.valueOf(FileUtils.getJsonByName("collectorid"));
//        String startCollectTime = String.valueOf(FileUtils.getJsonByName("startCollectTime"));
//        String isStartCollect = String.valueOf(FileUtils.getJsonByName("isStartCollect"));
//        if(collectorid.equals(Codes.ZZCODE.getCode())&& StringUtils.isNotBlank(startCollectTime)&&isStartCollect!=null&&isStartCollect.equals("1")){
//            bgtsService.collectAll();
//        }
//    }




    //在spring容器关闭时，释放
    @PreDestroy
    public void destroy() {
        //系统运行结束
    }

}
