package com.docus.bgts.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 在院封存
 * </p>
 *
 * @author jiashi
 * @since 2023-05-16
 */
@Data
@ApiModel(value="TSeal对象", description="在院封存")
public class TSeal implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "在院封存病案主键")
    private String patientId;

    @ApiModelProperty(value = "封存id")
    private String sealId;

    @ApiModelProperty(value = "住院号")
    private String inpatientNo;

    @ApiModelProperty(value = "住院就诊号")
    private String jzh;

    @ApiModelProperty(value = "患者姓名")
    private String name;

    @ApiModelProperty(value = "住院时间")
    private Date admissDate;

    @ApiModelProperty(value = "封存时间")
    private Date sealDate;

    @ApiModelProperty(value = "文件来源")
    private Integer fileSource;

    @ApiModelProperty(value = "就诊次数")
    private Integer admissTimes;

    @ApiModelProperty(value = "纸质是否签名 0：否 1：是")
    private Integer signinfo;

    @ApiModelProperty(value = "备注")
    private String remark;

    public TSeal() {
    }

}
