package com.docus.bgts.facade;
public interface IBgtsService {
    /**
     * 根据封存id进行封存病案的重症病历采集
     * @date 2024/1/11 10:27
     * @author YongBin Wen
     * @param sealId 封存id
     */
    void collectSealIcu(String sealId) throws Exception;

    /**
     * 根据封存id进行封存病案的手麻病历采集
     * @date 2024/1/11 10:27
     * @author YongBin Wen
     * @param sealId 封存id
     */
    void collectSealSurgicalAnesthesia(String sealId) throws Exception;

    /**
     * 采集
     * @param empId
     */
    void collect(String empId) throws Exception;

    /**
     * 根据封存id进行封存病案的内镜病历采集
     * @date 2024/1/11 10:27
     * @author YongBin Wen
     * @param sealId 封存id
     */
    void collectSealEndoscopy(String sealId) throws Exception;

    void collectPacs(String empId,String admissDate,String disDate,String times) throws Exception;

    /**
     * 根据封存id进行封存病案的pacs病历采集
     * @date 2024/1/11 10:27
     * @author YongBin Wen
     * @param sealId 封存id
     */
    void collectSealPacs(String sealId) throws Exception;


    void collectEcg(String empId,String admissDate,String disDate,String times) throws Exception;
    /**
     * 根据封存id进行封存病案的 心电图 病历采集
     * @date 2024/1/11 10:27
     * @author YongBin Wen
     * @param sealId 封存id
     */
    void collectSealEcg(String sealId) throws Exception;

    void collectPacss();
    /**
     * 按需采集
     * @param emamNo
     * @param empId
     */
    void collectByExamNo(String emamNo, String empId) throws  Exception;

    /**
     * 根据时间批量按需采集
     *
     * @param startDate   开始时间
     * @param endDate     结束时间
     * @param collectorId 采集器编号
     */
    void collectByDate(String startDate,String endDate,String collectorId);

    /**
     * 全量采集
     */
    void collectAll();

    /**
     * 定时采集
     */
    void timerCollect();



}
