package com.docus.bgts.mapper.dboracle;

import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface VDocumentPdfMapper {
    /**
     * 获取采集数据
     * @param current
     * @param size
     * @param startCollectTime
     * @param date
     * @return
     */
    List<Map> listCollectPage(@Param("current") int current,
                              @Param("size") int size,
                              @Param("startTime") String startCollectTime,
                              @Param("endTime") String date,
                              @Param("namespace") String namespace,
                              @Param("tableName") String tableName,
                              @Param("fieldArr") List<String> fieldArr,
                              @Param("collectTimeName") String collectTimeName);

    /**
     * 根据记账号获取采集数据
     *
     * @param jzhField  记账号字段
     * @param jzhVal    记账号值
     * @param namespace 命名空间
     * @param tableName 表
     * @param fieldArr  查询字段
     * @return java.util.List<java.util.Map>
     * @date 2024/1/11 17:08
     * @author YongBin Wen
     */
    List<Map> collectByJzh(@Param("jzhField") String jzhField,
                           @Param("jzhVal") String jzhVal,
                           @Param("namespace") String namespace,
                           @Param("tableName") String tableName,
                           @Param("fieldArr") List<String> fieldArr);
}
